import numpy as np

class charge:
    def __init__(self, x, y, name):
        self.x = x
        self.y = y
        self.name = name
        
        while not(self.valid()):
            self.x = np.random.uniform(-1, 1)
            self.y = np.random.uniform(-1, 1)
        
        self.maybe_x = self.x
        self.maybe_y = self.y
    
    def valid(self):
        return np.sqrt(self.x**2 + self.y**2) < 1 
    
    def maybe_valid(self):
        return np.sqrt(self.maybe_x**2 + self.maybe_y**2) < 1 
    
    def nudge(self, amt):
        self.maybe_x = 10
        self.maybe_y = 10
        while not(self.maybe_valid()):
            self.maybe_x = self.x + np.random.normal(0, amt)
            self.maybe_y = self.y + np.random.normal(0, amt)
        
        
    def accept(self):
        self.x = self.maybe_x
        self.y = self.maybe_y

def energy(charges):
    e_tot = 0
    for me in charges:
        for other in charges:
            if me.name == other.name:
                continue
            distance = (me.maybe_x - other.maybe_x)**2 + (me.maybe_y - other.maybe_y)**2
            e_tot += 1/distance
    return e_tot
        

def run(parts, its, output, name):
    charges = [charge(10, 10, i) for i in range(parts)]
    ene = 10000
    history = []
    temp = 100
    for i in range(its):
        output.put((name, i))
        [c.nudge(temp) for c in charges]
        e = energy(charges)
        if e > ene:
            ene = e
            [c.accept() for c in charges]
            temp = 22000 - 1/e
        history.append(ene)
        
    output.put((name, history, charges))